SystemOrganization addCategory: #MailSortingOffice!
SystemOrganization addCategory: 'MailSortingOffice-Core'!
SystemOrganization addCategory: 'MailSortingOffice-Morphic'!
SystemOrganization addCategory: 'MailSortingOffice-Test'!

Morph subclass: #PigeonHoleMorph
	instanceVariableNames: 'model nameMorph listMorph mainController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:36'!
diveStack
	MailSortingOfficeController new
		model: 
			(MailSortingOffice new
				mails: model stack;
				examination: model office examination;
				missionMessage: (UIManager default request: 'question text' initialAnswer: 'Liehs ioiws?');
				makePigeonHolesWithNames: (Compiler evaluate: (UIManager default request: 'Pigeonhole names' initialAnswer: '#(''small''  ''big'')')) );
		open.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:26'!
initialize
	| q buttonHeight |
	super initialize.
	buttonHeight := 30.
	self layoutPolicy: ProportionalLayout new.
	self color: Color gray.
	q := QuickPrototyping for: self.
	nameMorph := q label: #nameString.
	self addMorph: nameMorph fullFrame: (LayoutFrame new leftFraction: 0 ; leftOffset: 1; rightFraction: 1; rightOffset: -1; topFraction: 0; bottomFraction: 0; bottomOffset: 14).
	listMorph := q fastList: #item.
	self addMorph: listMorph fullFrame: (LayoutFrame new leftFraction: 0; leftOffset: 1; rightFraction: 1; rightOffset: -1; topFraction: 0; topOffset: 20; bottomFraction: 1; bottomOffset: -1 - buttonHeight).
	self addMorph: (q button: 'inspect' action: #inspectStack) fullFrame: (LayoutFrame new leftFraction: 0; leftOffset: 1; rightFraction: 0.5; rightOffset: -1; topFraction: 1; topOffset: 1 - buttonHeight; bottomFraction: 1; bottomOffset: -1).
	self addMorph: (q button: '...' action: #openEtcMenu) fullFrame: (LayoutFrame new leftFraction: 0.5; leftOffset: 1; rightFraction: 1; rightOffset: -1; topFraction: 1; topOffset: 1 - buttonHeight; bottomFraction: 1; bottomOffset: -1).
	
	self extent: 90@180.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 06:24'!
inspectStack
	model stack inspect! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:49'!
itemListElementAt: anInteger 
	^model examinedStackAt: anInteger ! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:04'!
itemListIndex
	^0! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:12'!
itemListIndex: anInteger 
	! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:17'!
itemListSize
	^model
		ifNil: [ 0 ]
		ifNotNil: [ model stack size ]! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:48'!
mainController: aMailSortingOfficeController
	mainController := aMailSortingOfficeController! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:42'!
model: aPigeonHole 
	model := aPigeonHole ! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:00'!
nameString
	^model
		ifNil: [ 'no model yet' ]
		ifNotNil: [ model name ]! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:37'!
openEtcMenu

	MenuMorph new
		add: 'no no no. Sort this again.' target: self action: #sortThisPigeonHoldAgain;
		add: 'dive' target: self action: #diveStack;
		popUpInWorld: self currentWorld! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
openInWorld: aMorph
	super openInWorld: aMorph.
	self updatePigeonHole! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:39'!
sortThisPigeonHoldAgain

	model pourPigeonHoleMailsOutToWorker.	
	self updatePigeonHole.
	mainController updateGUI.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
update: aSymbol.
	aSymbol = #pigeonHole ifTrue: [ self updatePigeonHole ].
	super update: aSymbol.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
updatePigeonHole

	self changed: #nameString.
	self changed: #itemListElementAt:.! !

TestCase subclass: #MailSortingOfficeHelloWorldTest
	instanceVariableNames: 'office'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Test'!

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:28'!
setUp
	super setUp.
	office := MailSortingOffice new.
	office mails: 'hello world'.
! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 16:42'!
testExamination

	office makePigeonHolesWithCount: 3.
		
	

	self assert: office examinationOfCurrentMail equals: $h.
	office examination: [ :mail| (String with: mail), '===' ].
	self assert: office examinationOfCurrentMail equals: 'h==='.
	
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.

	self assert: office pigeonHoleExaminations equals: #(() ('h===') ()).
	office examination: [ :mail| (String with: mail), 'T3' ].
	self assert: office pigeonHoleExaminations equals: #(() ('hT3') ()).! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 16:42'!
testNumberOfPigeonHolds
	
	office makePigeonHolesWithCount: 3.

	self assert: office numberOfPigeonHolds equals: 3.! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
testPigeonHolesWithNames

	office makePigeonHolesWithNames: {'vowel'. 'consonant'}.

	self assert: office pigeonHoleContents equals: #(() ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h)).

	self assert: office currentMail equals: $e.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($e) ($h)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).
	
	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	
	self assert: office pigeonHoleContents equals: #(($e) ($l $l $h)).
	self assert: office currentMail equals: $o.

	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($o $e) ($l $l $h)).

! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:50'!
testPigeonHolesWithNamesRedo

	office makePigeonHolesWithNames: {'vowel'. 'consonant'}.

	self assert: office pigeonHoleContents equals: #(() ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h)).

	self assert: office currentMail equals: $e.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($e) ($h)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).
	
	office undo.
	self assert: office currentMail equals: $l.
	self assert: office pigeonHoleContents equals: #(($e) ($h)).
	
	office redo.
	self assert: office currentMail equals: $l.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
testPigeonHolesWithNamesUndo

	office makePigeonHolesWithNames: {'vowel'. 'consonant'}.

	self assert: office pigeonHoleContents equals: #(() ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h)).

	self assert: office currentMail equals: $e.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($e) ($h)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).
	
	office undo.
	self assert: office currentMail equals: $l.
	self assert: office pigeonHoleContents equals: #(($e) ($h)).
	
	office undo.
	self assert: office currentMail equals: $e.
	self assert: office pigeonHoleContents equals: #(() ($h)).! !

!MailSortingOfficeHelloWorldTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 16:42'!
testTossCurrentMailIntoPigeonHoleAtIndex

	office makePigeonHolesWithCount: 3.

	self assert: office pigeonHoleContents equals: #(() () ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h) ()).

	self assert: office currentMail equals: $e.	
	office tossCurrentMailIntoPigeonHoleAtIndex: 3.
	self assert: office pigeonHoleContents equals: #(() ($h) ($e)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 3.
	self assert: office pigeonHoleContents equals: #(() ($h) ($l $e)).
	
	self assert: office currentMail equals: $l.	
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.
	self assert: office pigeonHoleContents equals: #(($l) ($h) ($l $e)).
	
	self assert: office currentMail equals: $o.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.
	self assert: office pigeonHoleContents equals: #(($o $l) ($h) ($l $e)).
! !

TestCase subclass: #MailSortingOfficeNumberTest
	instanceVariableNames: 'office'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Test'!

!MailSortingOfficeNumberTest commentStamp: '' prior: 0!
A MailSortingOfficeHelloWorldTest is xxxxxxxxx.

Instance Variables
	office:		<Object>

office
	- xxxxx
!

!MailSortingOfficeNumberTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:09'!
setUp
	super setUp.
	office := MailSortingOffice new.
	office mails: (1 to: 20) asArray.
! !

!MailSortingOfficeNumberTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 16:42'!
testPourBack

	office makePigeonHolesWithCount: 5.

	4 timesRepeat: [(1 to: 5) do: [:idx| office tossCurrentMailIntoPigeonHoleAtIndex: idx]].
	
	self assert: office pigeonHoleContents equals: #(#(16 11 6 1) #(17 12 7 2) #(18 13 8 3) #(19 14 9 4) #(20 15 10 5)).
	
	office pourOutToWorkerThatPigeonHoleMailsAtIndex: 2.
	
	self assert: office pigeonHoleContents equals: #(#(16 11 6 1) #() #(18 13 8 3) #(19 14 9 4) #(20 15 10 5)).
	
	office undo.
	
	self assert: office pigeonHoleContents equals: #(#(16 11 6 1) #(17 12 7 2) #(18 13 8 3) #(19 14 9 4) #(20 15 10 5)).! !

Object subclass: #MSOCommand
	instanceVariableNames: 'mailSortingOffice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!MSOCommand commentStamp: 'HwaJong 1/27/2014 00:07' prior: 0!
h!

!MSOCommand methodsFor: 'accessing' stamp: 'HwaJong 1/26/2014 23:55'!
mailSortingOffice

	^mailSortingOffice! !

!MSOCommand methodsFor: 'accessing' stamp: 'HwaJong 1/26/2014 23:55'!
mailSortingOffice: anMailSortingOffice
		
	mailSortingOffice := anMailSortingOffice! !

MSOCommand subclass: #MSOPourPigeonHoleMailsOutToWorker
	instanceVariableNames: 'pigeonHoleIndex mailCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!MSOPourPigeonHoleMailsOutToWorker commentStamp: '' prior: 0!
A MSOTossIntoPigeonHole is xxxxxxxxx.

Instance Variables
	pigeonHoleIndex:		<Object>

pigeonHoleIndex
	- xxxxx
!

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/9/2014 19:12'!
executeRedo
	|theStack|
	theStack := (mailSortingOffice pigeonHoles at: pigeonHoleIndex) stack.
	mailSortingOffice mailOrderedCollection addAllFirst: theStack reverse.
	theStack removeAll.! !

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:33'!
executeUndo
	|tossCommand|
	tossCommand := MSOTossIntoPigeonHole new 
		mailSortingOffice: mailSortingOffice; 
		pigeonHoleIndex: pigeonHoleIndex.
	mailCount timesRepeat: [ tossCommand executeRedo ]! !

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:20'!
mailCount
	^mailCount! !

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:20'!
mailCount: anInteger
	mailCount := anInteger! !

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:06'!
pigeonHoleIndex
	^pigeonHoleIndex! !

!MSOPourPigeonHoleMailsOutToWorker methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:06'!
pigeonHoleIndex: anInteger
	pigeonHoleIndex := anInteger! !

MSOCommand subclass: #MSOTossIntoPigeonHole
	instanceVariableNames: 'pigeonHoleIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!MSOTossIntoPigeonHole commentStamp: 'HwaJong 1/27/2014 00:07' prior: 0!
hi!

!MSOTossIntoPigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:31'!
executeRedo
	[ mailSortingOffice mailOrderedCollection isEmpty not ] assert.
	(mailSortingOffice pigeonHoles at: pigeonHoleIndex) stack addFirst: mailSortingOffice mailOrderedCollection removeFirst.! !

!MSOTossIntoPigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:01'!
executeUndo
	mailSortingOffice pickUpFromPigeonHoleAtIndex: pigeonHoleIndex.! !

!MSOTossIntoPigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:56'!
pigeonHoleIndex
	^pigeonHoleIndex! !

!MSOTossIntoPigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:56'!
pigeonHoleIndex: anInteger
	pigeonHoleIndex := anInteger! !

Object subclass: #MailSortingOffice
	instanceVariableNames: 'pigeonHoles missionMessage undoRedo mailOrderedCollection examination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!MailSortingOffice commentStamp: 'HwaJong 1/27/2014 00:07' prior: 0!
hi!

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:58'!
canRedo
	^self undoRedo canRedo! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:41'!
canUndo
	^self undoRedo canUndo! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 08:10'!
currentMail
	^mailOrderedCollection isEmpty
		ifTrue: [nil]
		ifFalse: [mailOrderedCollection first]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:45'!
examination
	^examination setDefault: #examinationDefault  for: self withSetter: #examination:! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:28'!
examination: aBlockClosure 
	examination := aBlockClosure! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:44'!
examinationDefault
	^[:obj| obj]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:45'!
examinationOfCurrentMail
	^self examination value: self currentMail! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:39'!
mailOrderedCollection
	^ mailOrderedCollection! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:32'!
mails: aSequenceableCollection 
	mailOrderedCollection := OrderedCollection withAll: aSequenceableCollection.! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 16:42'!
makePigeonHolesWithCount: anInteger 
	self makePigeonHolesWithNames: ( (1 to: anInteger) collect: [:each| each printString] )! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:36'!
makePigeonHolesWithNames: aCollection
	pigeonHoles := aCollection
		collect: [ :string | 
			PigeonHole new
				office: self;
				name: string;
				stack: OrderedCollection new ].! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:39'!
missionMessage
	^ missionMessage! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:38'!
missionMessage: aString 
	missionMessage := aString! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:10'!
numberOfPigeonHolds
	^pigeonHoles size! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 08:10'!
pickUpFromPigeonHoleAtIndex: anInteger 
	mailOrderedCollection addFirst: (self pigeonHoles at: anInteger) stack removeFirst! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:09'!
pigeonHoleContents
	^pigeonHoles collect: [ :each| each stack asArray ]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:45'!
pigeonHoleExaminations
	^pigeonHoles collect: [ :each| (each stack collect: self examination) asArray ]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:19'!
pigeonHoles
	^ pigeonHoles! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:41'!
pourOutToWorkerThatMailsOfPigeonHole: aPigeonHole 
	self pourOutToWorkerThatPigeonHoleMailsAtIndex: (pigeonHoles indexOf: aPigeonHole)! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/9/2014 19:15'!
pourOutToWorkerThatPigeonHoleMailsAtIndex: anInteger 

	| command |
	command := 
		MSOPourPigeonHoleMailsOutToWorker new 
			mailSortingOffice: self; 
			pigeonHoleIndex: anInteger; 
			mailCount: ((pigeonHoles at: anInteger) stack) size.
	command executeRedo.
	self undoRedo add: command! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:54'!
redo
	|command|
	self undoRedo redo.
	command := self undoRedo currentItem.
	command executeRedo.
	^command! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 08:10'!
remainingCount
	^mailOrderedCollection size! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:32'!
tossCurrentMailIntoPigeonHoleAtIndex: anInteger 
	| command |
	command := MSOTossIntoPigeonHole new 
			mailSortingOffice: self; 
			pigeonHoleIndex: anInteger.
	command executeRedo.		
	self undoRedo add: command.! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:03'!
undo
	|command|
	command := self undoRedo currentItem.
	command executeUndo.
	self undoRedo undo.
	^command! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:19'!
undoRedo
	^undoRedo setDefault: #undoRedoDefault for: self withSetter: #undoRedo:! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:20'!
undoRedo: anUndoRedo 
	undoRedo := anUndoRedo! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:20'!
undoRedoDefault
	^UndoRedo new! !

Object subclass: #MailSortingOfficeController
	instanceVariableNames: 'model pigeonHoleMorphs currentMailMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Morphic'!

!MailSortingOfficeController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:43'!
openWithMissionMessage: aString mails: aCollection pigeonHoleNames: aCollection3 
	
self new
	model: 
		(MailSortingOffice new
		missionMessage: aString;
		makePigeonHolesWithNames: aCollection3;
		mails: aCollection);
	open.
	! !

!MailSortingOfficeController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:46'!
openWithMissionMessage: aString mails: aCollection pigeonHoleNames: aCollection3 examination: aBlockClosure 

self new
	model: 
		(MailSortingOffice new
		missionMessage: aString;
		makePigeonHolesWithNames: aCollection3;
		mails: aCollection;
		examination: aBlockClosure);
	open.
	! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:29'!
currentMail
	^model remainingCount isZero
		ifTrue: [ '' ]
		ifFalse: [model examinationOfCurrentMail printString]! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 04:56'!
missionMessage
	^'"',model missionMessage,'"'! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:11'!
model: aMailSortingOffice 
	model := aMailSortingOffice! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 06:17'!
numberKeyPressed: anInteger 
	|exit|
	exit := [:af| ^self inform: 'no more'].
	[[model tossCurrentMailIntoPigeonHoleAtIndex: anInteger] on: SubscriptOutOfBounds do: exit] on: AssertionFailure do: exit.
	(pigeonHoleMorphs at: anInteger) updatePigeonHole.
	self changed: #currentMail.
	self changed: #remainingCountString.! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 21:56'!
open
	| q window msg remainCounter labelHeight margin amsg acurr |
	labelHeight := 30.
	margin := 30.
	q := QuickPrototyping for: self.
	window := StandardWindow new.
	msg := q label: #missionMessage.
	
	window addMorph: (amsg := AlignmentMorph newColumn
	wrapCentering: #center; cellPositioning: #center;
	hResizing: #shrinkWrap;
	vResizing: #spaceFill;
	layoutInset: 0@20;
	addMorph: (msg)) frame: (LayoutFrame new leftFraction: 0 ; leftOffset: margin; rightFraction: 1; rightOffset: margin negated; topFraction: 0; topOffset: margin;bottomFraction: 0; bottomOffset: margin+labelHeight+margin).
	msg color: Color black.
	msg font: (StandardFonts windowTitleFont).
	amsg color: Color transparent.
	
	remainCounter := q label: #remainingCountString.
	window addMorph: (remainCounter) frame: (LayoutFrame new leftFraction: 1 ; leftOffset: margin negated; rightFraction: 1; rightOffset: 0; topFraction: 0; topOffset: margin;bottomFraction: 0; bottomOffset: margin+labelHeight+margin).
	remainCounter color: Color black.
	
	currentMailMorph := q label: #currentMail.
	acurr := AlignmentMorph newColumn
	wrapCentering: #center; cellPositioning: #center;
	hResizing: #shrinkWrap;
	vResizing: #spaceFill;
	layoutInset: 0@20;
	addMorph: (currentMailMorph).
	window addMorph: (acurr) frame: (LayoutFrame new leftFraction: 0 ; leftOffset: margin; rightFraction: 1; rightOffset: margin negated; topFraction: 0; topOffset: margin+labelHeight+margin; bottomFraction: 0; bottomOffset: margin+labelHeight+margin+labelHeight+margin).
	currentMailMorph color: Color black.
	currentMailMorph font: (StandardFonts windowTitleFont).
	acurr color: Color transparent.
	
	pigeonHoleMorphs := OrderedCollection new.
	model pigeonHoles keysAndValuesDo: [:th :each| 
		|pm|
		pm := PigeonHoleMorph new model: each; mainController: self.
		pigeonHoleMorphs add: pm. window addMorph: pm frame: (LayoutFrame fractions: (((th-1)/model pigeonHoles size)@0 extent:  (1 / model pigeonHoles size)@1 ) offsets: (0@(margin+labelHeight+margin+labelHeight+margin) corner: 0@ 0)).
		window on: (Character digitValue: th) do: [self numberKeyPressed: th ] ].
	window setLabel: 'Mail Sorting Office'.
	window openInWorld.
	window on: $z do: [ self undo ].
	window on: $y do: [ self redo ].
	pigeonHoleMorphs do: [ :each| each updatePigeonHole ]! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 22:01'!
redo
	model canRedo
		ifTrue: 
			[| command |
			command := model redo.
			(pigeonHoleMorphs at: command pigeonHoleIndex) updatePigeonHole.
			self changed: #currentMail.
			self changed: #remainingCountString.]
		ifFalse: [ self inform: 'Cannot redo.' ]! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 06:16'!
remainingCountString
	^model remainingCount printString! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 22:00'!
undo
	model canUndo
		ifTrue: 
			[| command |
			command := model undo.
			(pigeonHoleMorphs at: command pigeonHoleIndex) updatePigeonHole.
			self changed: #currentMail.
			self changed: #remainingCountString.]
		ifFalse: [ self inform: 'Cannot undo.' ]! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:49'!
updateGUI
	self changed: #currentMail.
	self changed: #remainingCountString.! !

Object subclass: #PigeonHole
	instanceVariableNames: 'name writeStream stack office'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!PigeonHole commentStamp: 'HwaJong 1/27/2014 00:07' prior: 0!
hi!

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:47'!
examinedStack
	^stack collect: office examination! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:50'!
examinedStackAt: anInteger
	^office examination value: (stack at: anInteger)! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:02'!
name
	^name! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:37'!
name: aString 
	name := aString! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 23:36'!
office
	^ office! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/26/2014 20:46'!
office: aMailSortingOffice
	office := aMailSortingOffice! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/27/2014 00:40'!
pourPigeonHoleMailsOutToWorker
	office pourOutToWorkerThatMailsOfPigeonHole: self! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:08'!
stack
	^stack! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:08'!
stack: anOrderedCollection
	stack := anOrderedCollection! !
